/* Generated by re2c 1.0.2 on Thu Sep  7 14:09:09 2017 */
#line 1 "src/parser.re"
/*******************************************************************************
 Copyright (c) 2016, Michael Wallner <mike@php.net>.
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

     * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
     * Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

#include "php_psi_stdinc.h"
#include <sys/mman.h>
#include <assert.h>
#include <stdarg.h>

#include "parser.h"

#define YYMAXFILL 15

#ifndef YYMAXFILL
# define YYMAXFILL 256
#endif

struct psi_parser *psi_parser_init(struct psi_parser *P, psi_error_cb error, unsigned flags)
{
	if (!P) {
		P = malloc(sizeof(*P));
	}
	memset(P, 0, sizeof(*P));

	psi_data_ctor_with_dtors(PSI_DATA(P), error, flags);

	P->preproc = psi_cpp_init(P);

	psi_cpp_load_defaults(P->preproc);

	return P;
}

struct psi_parser_input *psi_parser_open_file(struct psi_parser *P, const char *filename, bool report_errors)
{
	struct stat sb;
	FILE *fp;
	struct psi_parser_input *fb;

	if (stat(filename, &sb)) {
		if (report_errors) {
			P->error(PSI_DATA(P), NULL, PSI_WARNING,
					"Could not stat '%s': %s",
					filename, strerror(errno));
		}
		return NULL;
	}

	if (!(fb = malloc(sizeof(*fb) + strlen(filename) + 1 + sb.st_size + YYMAXFILL))) {
		if (report_errors) {
			P->error(PSI_DATA(P), NULL, PSI_WARNING,
					"Could not allocate %zu bytes for reading '%s': %s",
					sb.st_size + YYMAXFILL, filename, strerror(errno));
		}
		return NULL;
	}

	if (!(fp = fopen(filename, "r"))) {
		free(fb);
		if (report_errors) {
			P->error(PSI_DATA(P), NULL, PSI_WARNING,
					"Could not open '%s' for reading: %s",
					filename, strerror(errno));
		}
		return NULL;
	}

	if (sb.st_size != fread(fb->buffer, 1, sb.st_size, fp)) {
		free(fb);
		fclose(fp);
		if (report_errors) {
			P->error(PSI_DATA(P), NULL, PSI_WARNING,
					"Could not read %zu bytes from '%s': %s",
					sb.st_size + YYMAXFILL, filename, strerror(errno));
		}
		return NULL;
	}

	memset(fb->buffer + sb.st_size, 0, YYMAXFILL);
	fb->length = sb.st_size;
	fb->file = &fb->buffer[sb.st_size + YYMAXFILL];
	memcpy(fb->file, filename, strlen(filename) + 1);

	return fb;
}

struct psi_parser_input *psi_parser_open_string(struct psi_parser *P, const char *string, size_t length)
{
	struct psi_parser_input *sb;

	if (!(sb = malloc(sizeof(*sb) + sizeof("<stdin>") + length + YYMAXFILL))) {
		P->error(PSI_DATA(P), NULL, PSI_WARNING,
				"Could not allocate %zu bytes: %s",
				length + YYMAXFILL, strerror(errno));
		return NULL;
	}

	memcpy(sb->buffer, string, length);
	memset(sb->buffer + length, 0, YYMAXFILL);

	sb->length = length;
	sb->file = &sb->buffer[length + YYMAXFILL];
	memcpy(sb->file, "<stdin>", sizeof("<stdin>"));

	return sb;
}

#if 0
static void psi_parser_register_constants(struct psi_parser *P)
{
	zend_string *key;
	zval *val;

	ZEND_HASH_FOREACH_STR_KEY_VAL(&P->cpp.defs, key, val)
	{
		struct psi_impl_def_val *iv;
		struct psi_const_type *ct;
		struct psi_const *c;
		const char *ctn;
		token_t ctt;
		impl_val tmp;
		zend_string *str;

		ZVAL_DEREF(val);
		switch (Z_TYPE_P(val)) {
		case IS_TRUE:
		case IS_FALSE:
			ctt = PSI_T_BOOL;
			ctn = "bool";
			tmp.zend.bval = Z_TYPE_P(val) == IS_TRUE;
			break;
		case IS_LONG:
			ctt = PSI_T_INT;
			ctn = "int";
			tmp.zend.lval = Z_LVAL_P(val);
			break;
		case IS_DOUBLE:
			ctt = PSI_T_FLOAT;
			ctn = "float";
			tmp.dval = Z_DVAL_P(val);
			break;
		default:
			ctt = PSI_T_STRING;
			ctn = "string";
			str = zval_get_string(val);
			tmp.zend.str = zend_string_dup(str, 1);
			zend_string_release(str);
			break;
		}

		iv = psi_impl_def_val_init(ctt, NULL);
		iv->ival = tmp;
		ct = psi_const_type_init(ctt, ctn);
		c = psi_const_init(ct, key->val, iv);
		if (!P->consts) {
			P->consts = psi_plist_init((psi_plist_dtor) psi_const_free);
		}
		P->consts = psi_plist_add(P->consts, &c);
	}
	ZEND_HASH_FOREACH_END();
}
#endif

struct psi_plist *psi_parser_preprocess(struct psi_parser *P, struct psi_plist **tokens)
{
	if (psi_cpp_process(P->preproc, tokens)) {
		return *tokens;
	}
	return NULL;
}

bool psi_parser_process(struct psi_parser *P, struct psi_plist *tokens, size_t *processed)
{
	if (psi_plist_count(tokens)) {
		return 0 == psi_parser_proc_parse(P, tokens, processed);
	}
	return true;
}

bool psi_parser_parse(struct psi_parser *P, struct psi_parser_input *I)
{
	struct psi_plist *scanned, *preproc;
	size_t processed = 0;

	if (!(scanned = psi_parser_scan(P, I))) {
		return false;
	}

	if (!(preproc = psi_parser_preprocess(P, &scanned))) {
		psi_plist_free(scanned);
		return false;
	}

	if (!psi_parser_process(P, preproc, &processed)) {
		psi_plist_free(preproc);
		return false;
	}

	psi_plist_free(preproc);
	return true;
}

void psi_parser_dtor(struct psi_parser *P)
{
	psi_cpp_free(&P->preproc);
	psi_data_dtor(PSI_DATA(P));

	memset(P, 0, sizeof(*P));
}

void psi_parser_free(struct psi_parser **P)
{
	if (*P) {
		psi_parser_dtor(*P);
		free(*P);
		*P = NULL;
	}
}

#define NEWLINE() \
	eol = cur; \
	++I->lines

#define NEWTOKEN(t) \
	token = psi_token_init(t, tok, cur - tok, tok - eol + 1, I->lines, I->file); \
	tokens = psi_plist_add(tokens, &token); \
	if (P->flags & PSI_DEBUG) { \
		fprintf(stderr, "PSI< "); \
		psi_token_dump(2, token); \
	}

union int_suffix {
	char s[SIZEOF_UINT32_T];
	uint32_t i;
};

struct psi_plist *psi_parser_scan(struct psi_parser *P, struct psi_parser_input *I)
{
	struct psi_plist *tokens;
	struct psi_token *token;
	const char *tok, *cur, *lim, *mrk, *eol, *ctxmrk;
	unsigned parens;
	bool escaped;
	token_t char_width;

	PSI_DEBUG_PRINT(P, "PSI: scanning %s\n", I->file);

	tok = mrk = eol = cur = I->buffer;
	lim = I->buffer + I->length;
	I->lines = 1;
	tokens = psi_plist_init((psi_plist_dtor) psi_token_free);

	start: ;
		char_width = 1;
		ctxmrk = NULL;
		tok = cur;

		
#line 283 "src/parser.c"
		{
			unsigned char yych;
			unsigned int yyaccept = 0;
			if ((lim - cur) < 15) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\v':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case '@':
			case '`':
			case 0x7F:	goto yy2;
			case '\t':
			case '\f':
			case ' ':	goto yy4;
			case '\n':
			case '\r':	goto yy7;
			case '!':	goto yy9;
			case '"':	goto yy11;
			case '#':	goto yy13;
			case '$':	goto yy15;
			case '%':	goto yy16;
			case '&':	goto yy18;
			case '\'':	goto yy20;
			case '(':	goto yy22;
			case ')':	goto yy24;
			case '*':	goto yy26;
			case '+':	goto yy28;
			case ',':	goto yy30;
			case '-':	goto yy32;
			case '.':	goto yy34;
			case '/':	goto yy36;
			case '0':	goto yy38;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			case ':':	goto yy42;
			case ';':	goto yy44;
			case '<':	goto yy46;
			case '=':	goto yy48;
			case '>':	goto yy50;
			case '?':	goto yy52;
			case 'A':
			case 'a':	goto yy54;
			case 'B':	goto yy56;
			case 'C':	goto yy57;
			case 'D':	goto yy58;
			case 'E':	goto yy59;
			case 'F':	goto yy60;
			case 'I':	goto yy63;
			case 'L':	goto yy64;
			case 'M':
			case 'm':	goto yy65;
			case 'N':
			case 'n':	goto yy66;
			case 'O':
			case 'o':	goto yy67;
			case 'P':	goto yy68;
			case 'R':
			case 'r':	goto yy69;
			case 'S':	goto yy70;
			case 'T':	goto yy71;
			case 'U':	goto yy72;
			case 'W':
			case 'w':	goto yy73;
			case 'Z':
			case 'z':	goto yy74;
			case '[':	goto yy75;
			case '\\':	goto yy77;
			case ']':	goto yy79;
			case '^':	goto yy81;
			case '_':	goto yy83;
			case 'b':	goto yy84;
			case 'c':	goto yy85;
			case 'd':	goto yy86;
			case 'e':	goto yy87;
			case 'f':	goto yy88;
			case 'i':	goto yy89;
			case 'l':	goto yy90;
			case 'p':	goto yy91;
			case 's':	goto yy92;
			case 't':	goto yy93;
			case 'u':	goto yy94;
			case 'v':	goto yy95;
			case '{':	goto yy96;
			case '|':	goto yy98;
			case '}':	goto yy100;
			case '~':	goto yy102;
			default:	goto yy61;
			}
yy2:
			++cur;
yy3:
#line 455 "src/parser.re"
			{ NEWTOKEN(-2); goto error; }
#line 410 "src/parser.c"
yy4:
			++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy4;
			default:	goto yy6;
			}
yy6:
#line 454 "src/parser.re"
			{ NEWTOKEN(PSI_T_WHITESPACE); goto start; }
#line 424 "src/parser.c"
yy7:
			++cur;
#line 453 "src/parser.re"
			{ NEWTOKEN(PSI_T_EOL); NEWLINE(); goto start; }
#line 429 "src/parser.c"
yy9:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy104;
			default:	goto yy10;
			}
yy10:
#line 349 "src/parser.re"
			{ NEWTOKEN(PSI_T_NOT); goto start; }
#line 439 "src/parser.c"
yy11:
			++cur;
#line 322 "src/parser.re"
			{ escaped = false; tok += 1; goto string; }
#line 444 "src/parser.c"
yy13:
			yych = *++cur;
			switch (yych) {
			case '#':	goto yy106;
			default:	goto yy14;
			}
yy14:
#line 332 "src/parser.re"
			{ NEWTOKEN(PSI_T_HASH); goto start; }
#line 454 "src/parser.c"
yy15:
			yych = *++cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy3;
			default:	goto yy108;
			}
yy16:
			++cur;
#line 350 "src/parser.re"
			{ NEWTOKEN(PSI_T_MODULO); goto start; }
#line 529 "src/parser.c"
yy18:
			yych = *++cur;
			switch (yych) {
			case '&':	goto yy111;
			default:	goto yy19;
			}
yy19:
#line 351 "src/parser.re"
			{ NEWTOKEN(PSI_T_AMPERSAND); goto start; }
#line 539 "src/parser.c"
yy20:
			++cur;
#line 321 "src/parser.re"
			{ escaped = false; tok += 1; goto character; }
#line 544 "src/parser.c"
yy22:
			++cur;
#line 333 "src/parser.re"
			{ NEWTOKEN(PSI_T_LPAREN); goto start; }
#line 549 "src/parser.c"
yy24:
			++cur;
#line 334 "src/parser.re"
			{ NEWTOKEN(PSI_T_RPAREN); goto start; }
#line 554 "src/parser.c"
yy26:
			++cur;
#line 347 "src/parser.re"
			{ NEWTOKEN(PSI_T_ASTERISK); goto start; }
#line 559 "src/parser.c"
yy28:
			yyaccept = 0;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy113;
			case '0':	goto yy38;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			default:	goto yy29;
			}
yy29:
#line 352 "src/parser.re"
			{ NEWTOKEN(PSI_T_PLUS); goto start; }
#line 580 "src/parser.c"
yy30:
			++cur;
#line 336 "src/parser.re"
			{ NEWTOKEN(PSI_T_COMMA); goto start; }
#line 585 "src/parser.c"
yy32:
			yyaccept = 1;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy113;
			case '0':	goto yy38;
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			default:	goto yy33;
			}
yy33:
#line 353 "src/parser.re"
			{ NEWTOKEN(PSI_T_MINUS); goto start; }
#line 606 "src/parser.c"
yy34:
			yyaccept = 2;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy115;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy116;
			default:	goto yy35;
			}
yy35:
#line 364 "src/parser.re"
			{ NEWTOKEN(PSI_T_PERIOD); goto start; }
#line 627 "src/parser.c"
yy36:
			yych = *++cur;
			switch (yych) {
			case '*':	goto yy119;
			case '/':	goto yy121;
			default:	goto yy37;
			}
yy37:
#line 354 "src/parser.re"
			{ NEWTOKEN(PSI_T_SLASH); goto start; }
#line 638 "src/parser.c"
yy38:
			yyaccept = 3;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '.':	goto yy123;
			case 'E':
			case 'e':	goto yy127;
			case 'X':
			case 'x':	goto yy132;
			default:	goto yy126;
			}
yy39:
#line 308 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT; goto start; }
#line 653 "src/parser.c"
yy40:
			yyaccept = 3;
			mrk = ++cur;
			if ((lim - cur) < 3) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '.':	goto yy123;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy40;
			case 'E':
			case 'e':	goto yy127;
			case 'L':
			case 'l':	goto yy128;
			case 'U':
			case 'u':	goto yy130;
			default:	goto yy39;
			}
yy42:
			++cur;
#line 337 "src/parser.re"
			{ NEWTOKEN(PSI_T_COLON); goto start; }
#line 683 "src/parser.c"
yy44:
			++cur;
#line 335 "src/parser.re"
			{ NEWTOKEN(PSI_T_EOS); goto start; }
#line 688 "src/parser.c"
yy46:
			yyaccept = 4;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy133;
			case '<':	goto yy135;
			case '=':	goto yy137;
			default:	goto yy47;
			}
yy47:
#line 362 "src/parser.re"
			{ NEWTOKEN(PSI_T_LCHEVR); goto start; }
#line 766 "src/parser.c"
yy48:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy139;
			default:	goto yy49;
			}
yy49:
#line 346 "src/parser.re"
			{ NEWTOKEN(PSI_T_EQUALS); goto start; }
#line 776 "src/parser.c"
yy50:
			yych = *++cur;
			switch (yych) {
			case '=':	goto yy141;
			case '>':	goto yy143;
			default:	goto yy51;
			}
yy51:
#line 363 "src/parser.re"
			{ NEWTOKEN(PSI_T_RCHEVR); goto start; }
#line 787 "src/parser.c"
yy52:
			++cur;
#line 366 "src/parser.re"
			{ NEWTOKEN(PSI_T_IIF); goto start; }
#line 792 "src/parser.c"
yy54:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy145;
			default:	goto yy62;
			}
yy55:
#line 448 "src/parser.re"
			{ NEWTOKEN(PSI_T_NAME); goto start; }
#line 804 "src/parser.c"
yy56:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy147;
			default:	goto yy62;
			}
yy57:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy148;
			case 'O':
			case 'o':	goto yy149;
			default:	goto yy62;
			}
yy58:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy150;
			default:	goto yy62;
			}
yy59:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy151;
			case 'N':
			case 'n':	goto yy152;
			case 'R':
			case 'r':	goto yy153;
			default:	goto yy62;
			}
yy60:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy154;
			case 'L':
			case 'l':	goto yy155;
			case 'R':
			case 'r':	goto yy156;
			case 'U':
			case 'u':	goto yy157;
			default:	goto yy62;
			}
yy61:
			yyaccept = 5;
			mrk = ++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
yy62:
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy63:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy158;
			case 'N':
			case 'n':	goto yy160;
			default:	goto yy62;
			}
yy64:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy161;
			case 'E':
			case 'e':	goto yy163;
			case 'I':
			case 'i':	goto yy164;
			default:	goto yy62;
			}
yy65:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy165;
			default:	goto yy62;
			}
yy66:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy166;
			default:	goto yy62;
			}
yy67:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy167;
			default:	goto yy62;
			}
yy68:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy168;
			case 'O':
			case 'o':	goto yy169;
			case 'R':
			case 'r':	goto yy170;
			default:	goto yy62;
			}
yy69:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy171;
			default:	goto yy62;
			}
yy70:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy172;
			case 'T':
			case 't':	goto yy173;
			default:	goto yy62;
			}
yy71:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy174;
			case 'O':
			case 'o':	goto yy175;
			case 'R':
			case 'r':	goto yy176;
			default:	goto yy62;
			}
yy72:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy177;
			case 'N':
			case 'n':	goto yy179;
			default:	goto yy62;
			}
yy73:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy180;
			default:	goto yy62;
			}
yy74:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy181;
			default:	goto yy62;
			}
yy75:
			++cur;
#line 340 "src/parser.re"
			{ NEWTOKEN(PSI_T_LBRACKET); goto start; }
#line 1049 "src/parser.c"
yy77:
			yych = *++cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy78;
			default:	goto yy182;
			}
yy78:
#line 355 "src/parser.re"
			{ NEWTOKEN(PSI_T_BSLASH); goto start; }
#line 1133 "src/parser.c"
yy79:
			++cur;
#line 341 "src/parser.re"
			{ NEWTOKEN(PSI_T_RBRACKET); goto start; }
#line 1138 "src/parser.c"
yy81:
			++cur;
#line 357 "src/parser.re"
			{ NEWTOKEN(PSI_T_CARET); goto start; }
#line 1143 "src/parser.c"
yy83:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy185;
			default:	goto yy62;
			}
yy84:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy147;
			case 'o':	goto yy186;
			default:	goto yy62;
			}
yy85:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy148;
			case 'O':	goto yy149;
			case 'h':	goto yy187;
			case 'o':	goto yy188;
			default:	goto yy62;
			}
yy86:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy150;
			case 'o':	goto yy189;
			default:	goto yy62;
			}
yy87:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy151;
			case 'N':	goto yy152;
			case 'R':
			case 'r':	goto yy153;
			case 'n':	goto yy190;
			default:	goto yy62;
			}
yy88:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy154;
			case 'L':	goto yy155;
			case 'R':
			case 'r':	goto yy156;
			case 'U':
			case 'u':	goto yy157;
			case 'l':	goto yy191;
			default:	goto yy62;
			}
yy89:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy158;
			case 'N':	goto yy160;
			case 'n':	goto yy192;
			default:	goto yy62;
			}
yy90:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy163;
			case 'I':	goto yy164;
			case 'i':	goto yy193;
			case 'o':	goto yy194;
			default:	goto yy62;
			}
yy91:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy168;
			case 'O':
			case 'o':	goto yy169;
			case 'R':	goto yy170;
			case 'r':	goto yy195;
			default:	goto yy62;
			}
yy92:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy172;
			case 'T':	goto yy173;
			case 'h':	goto yy196;
			case 'i':	goto yy197;
			case 't':	goto yy198;
			default:	goto yy62;
			}
yy93:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy174;
			case 'O':
			case 'o':	goto yy175;
			case 'R':
			case 'r':	goto yy176;
			case 'y':	goto yy199;
			default:	goto yy62;
			}
yy94:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':
			case '\'':	goto yy200;
			case '8':	goto yy202;
			case 'N':	goto yy179;
			case 'i':	goto yy203;
			case 'n':	goto yy204;
			default:	goto yy62;
			}
yy95:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy205;
			default:	goto yy62;
			}
yy96:
			++cur;
#line 338 "src/parser.re"
			{ NEWTOKEN(PSI_T_LBRACE); goto start; }
#line 1286 "src/parser.c"
yy98:
			yych = *++cur;
			switch (yych) {
			case '|':	goto yy206;
			default:	goto yy99;
			}
yy99:
#line 356 "src/parser.re"
			{ NEWTOKEN(PSI_T_PIPE); goto start; }
#line 1296 "src/parser.c"
yy100:
			++cur;
#line 339 "src/parser.re"
			{ NEWTOKEN(PSI_T_RBRACE); goto start; }
#line 1301 "src/parser.c"
yy102:
			++cur;
#line 348 "src/parser.re"
			{ NEWTOKEN(PSI_T_TILDE); goto start; }
#line 1306 "src/parser.c"
yy104:
			++cur;
#line 342 "src/parser.re"
			{ NEWTOKEN(PSI_T_CMP_NE); goto start; }
#line 1311 "src/parser.c"
yy106:
			++cur;
#line 331 "src/parser.re"
			{ NEWTOKEN(PSI_T_CPP_PASTE); goto start; }
#line 1316 "src/parser.c"
yy108:
			++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy110;
			default:	goto yy108;
			}
yy110:
#line 450 "src/parser.re"
			{ NEWTOKEN(PSI_T_DOLLAR_NAME); goto start; }
#line 1392 "src/parser.c"
yy111:
			++cur;
#line 344 "src/parser.re"
			{ NEWTOKEN(PSI_T_AND); goto start; }
#line 1397 "src/parser.c"
yy113:
			yych = *++cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy116;
			default:	goto yy114;
			}
yy114:
			cur = mrk;
			switch (yyaccept) {
			case 0: 	goto yy29;
			case 1: 	goto yy33;
			case 2: 	goto yy35;
			case 3: 	goto yy39;
			case 4: 	goto yy47;
			case 5: 	goto yy55;
			case 6: 	goto yy118;
			case 7: 	goto yy129;
			case 8: 	goto yy159;
			case 9: 	goto yy184;
			case 10: 	goto yy241;
			case 11: 	goto yy243;
			case 12: 	goto yy252;
			case 13: 	goto yy272;
			case 14: 	goto yy305;
			case 15: 	goto yy307;
			case 16: 	goto yy313;
			case 17: 	goto yy321;
			case 18: 	goto yy333;
			case 19: 	goto yy341;
			case 20: 	goto yy345;
			case 21: 	goto yy352;
			case 22: 	goto yy354;
			case 23: 	goto yy358;
			case 24: 	goto yy365;
			case 25: 	goto yy367;
			case 26: 	goto yy378;
			case 27: 	goto yy381;
			case 28: 	goto yy388;
			case 29: 	goto yy391;
			case 30: 	goto yy393;
			case 31: 	goto yy395;
			case 32: 	goto yy399;
			case 33: 	goto yy404;
			case 34: 	goto yy422;
			case 35: 	goto yy430;
			case 36: 	goto yy433;
			case 37: 	goto yy440;
			case 38: 	goto yy450;
			case 39: 	goto yy454;
			case 40: 	goto yy459;
			case 41: 	goto yy461;
			case 42: 	goto yy465;
			case 43: 	goto yy468;
			case 44: 	goto yy470;
			case 45: 	goto yy472;
			case 46: 	goto yy477;
			case 47: 	goto yy479;
			case 48: 	goto yy481;
			case 49: 	goto yy483;
			case 50: 	goto yy485;
			case 51: 	goto yy490;
			case 52: 	goto yy500;
			case 53: 	goto yy505;
			case 54: 	goto yy507;
			case 55: 	goto yy509;
			case 56: 	goto yy511;
			case 57: 	goto yy513;
			case 58: 	goto yy522;
			case 59: 	goto yy526;
			case 60: 	goto yy530;
			case 61: 	goto yy532;
			case 62: 	goto yy537;
			case 63: 	goto yy542;
			case 64: 	goto yy544;
			case 65: 	goto yy550;
			case 66: 	goto yy552;
			case 67: 	goto yy554;
			case 68: 	goto yy558;
			case 69: 	goto yy563;
			case 70: 	goto yy567;
			case 71: 	goto yy569;
			case 72: 	goto yy571;
			case 73: 	goto yy573;
			case 74: 	goto yy578;
			case 75: 	goto yy580;
			case 76: 	goto yy586;
			case 77: 	goto yy591;
			case 78: 	goto yy593;
			case 79: 	goto yy595;
			case 80: 	goto yy597;
			case 81: 	goto yy599;
			case 82: 	goto yy604;
			case 83: 	goto yy606;
			case 84: 	goto yy614;
			case 85: 	goto yy618;
			case 86: 	goto yy622;
			case 87: 	goto yy626;
			case 88: 	goto yy628;
			default:	goto yy633;
			}
yy115:
			yych = *++cur;
			switch (yych) {
			case '.':	goto yy208;
			default:	goto yy114;
			}
yy116:
			yyaccept = 6;
			mrk = ++cur;
			if ((lim - cur) < 2) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy116;
			case 'D':
			case 'd':	goto yy210;
			case 'F':
			case 'f':	goto yy211;
			case 'L':
			case 'l':	goto yy213;
			default:	goto yy118;
			}
yy118:
#line 314 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT; goto start; }
#line 1540 "src/parser.c"
yy119:
			++cur;
#line 328 "src/parser.re"
			{ goto comment; }
#line 1545 "src/parser.c"
yy121:
			++cur;
#line 329 "src/parser.re"
			{ goto comment_sl; }
#line 1550 "src/parser.c"
yy123:
			yyaccept = 6;
			mrk = ++cur;
			if ((lim - cur) < 3) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy123;
			case 'D':
			case 'd':	goto yy210;
			case 'E':
			case 'e':	goto yy127;
			case 'F':
			case 'f':	goto yy211;
			case 'L':
			case 'l':	goto yy213;
			default:	goto yy118;
			}
yy125:
			++cur;
			if ((lim - cur) < 3) if (cur >= lim) goto done;;
			yych = *cur;
yy126:
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':	goto yy125;
			case 'L':
			case 'l':	goto yy128;
			case 'U':
			case 'u':	goto yy130;
			default:	goto yy39;
			}
yy127:
			yych = *++cur;
			switch (yych) {
			case '+':
			case '-':	goto yy113;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy116;
			default:	goto yy114;
			}
yy128:
			yyaccept = 7;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy215;
			case 'U':
			case 'u':	goto yy216;
			default:	goto yy129;
			}
yy129:
			cur -= 1;
#line 310 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_L; cur += 1; goto start; }
#line 1628 "src/parser.c"
yy130:
			yych = *++cur;
			switch (yych) {
			case 'L':
			case 'l':	goto yy218;
			default:	goto yy131;
			}
yy131:
			cur -= 1;
#line 309 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_U; cur += 1; goto start; }
#line 1640 "src/parser.c"
yy132:
			yych = *++cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy219;
			default:	goto yy114;
			}
yy133:
			++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy133;
			case '>':	goto yy221;
			default:	goto yy114;
			}
yy135:
			++cur;
#line 358 "src/parser.re"
			{ NEWTOKEN(PSI_T_LSHIFT); goto start; }
#line 1746 "src/parser.c"
yy137:
			++cur;
#line 360 "src/parser.re"
			{ NEWTOKEN(PSI_T_CMP_LE); goto start; }
#line 1751 "src/parser.c"
yy139:
			++cur;
#line 343 "src/parser.re"
			{ NEWTOKEN(PSI_T_CMP_EQ); goto start; }
#line 1756 "src/parser.c"
yy141:
			++cur;
#line 361 "src/parser.re"
			{ NEWTOKEN(PSI_T_CMP_GE); goto start; }
#line 1761 "src/parser.c"
yy143:
			++cur;
#line 359 "src/parser.re"
			{ NEWTOKEN(PSI_T_RSHIFT); goto start; }
#line 1766 "src/parser.c"
yy145:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy223;
			default:	goto yy62;
			}
yy146:
			++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case '\\':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy114;
			default:	goto yy182;
			}
yy147:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy224;
			default:	goto yy62;
			}
yy148:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy225;
			default:	goto yy62;
			}
yy149:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy226;
			default:	goto yy62;
			}
yy150:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy227;
			default:	goto yy62;
			}
yy151:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy228;
			case 'S':
			case 's':	goto yy229;
			default:	goto yy62;
			}
yy152:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy230;
			default:	goto yy62;
			}
yy153:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy231;
			default:	goto yy62;
			}
yy154:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy232;
			default:	goto yy62;
			}
yy155:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy233;
			default:	goto yy62;
			}
yy156:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy234;
			default:	goto yy62;
			}
yy157:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy235;
			default:	goto yy62;
			}
yy158:
			yyaccept = 8;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy159;
			case 'D':
			case 'd':	goto yy236;
			case 'N':
			case 'n':	goto yy237;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy159:
#line 399 "src/parser.re"
			{ NEWTOKEN(PSI_T_IF); goto start; }
#line 2025 "src/parser.c"
yy160:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy238;
			case 'T':
			case 't':	goto yy239;
			default:	goto yy62;
			}
yy161:
			++cur;
			cur -= 1;
#line 326 "src/parser.re"
			{ char_width = SIZEOF_WCHAR_T/8; }
#line 2041 "src/parser.c"
yy163:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy240;
			default:	goto yy62;
			}
yy164:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy242;
			default:	goto yy62;
			}
yy165:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'X':
			case 'x':	goto yy244;
			default:	goto yy62;
			}
yy166:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy245;
			default:	goto yy62;
			}
yy167:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'J':
			case 'j':	goto yy246;
			default:	goto yy62;
			}
yy168:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy247;
			default:	goto yy62;
			}
yy169:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy248;
			default:	goto yy62;
			}
yy170:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy249;
			default:	goto yy62;
			}
yy171:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy250;
			default:	goto yy62;
			}
yy172:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy251;
			default:	goto yy62;
			}
yy173:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy253;
			case 'R':
			case 'r':	goto yy254;
			default:	goto yy62;
			}
yy174:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'M':
			case 'm':	goto yy255;
			default:	goto yy62;
			}
yy175:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy256;
			default:	goto yy62;
			}
yy176:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy257;
			default:	goto yy62;
			}
yy177:
			++cur;
			cur -= 1;
#line 325 "src/parser.re"
			{ char_width = 4; }
#line 2160 "src/parser.c"
yy179:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy258;
			default:	goto yy62;
			}
yy180:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy259;
			default:	goto yy62;
			}
yy181:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy260;
			default:	goto yy62;
			}
yy182:
			yyaccept = 9;
			mrk = ++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy184;
			case '\\':	goto yy146;
			default:	goto yy182;
			}
yy184:
#line 449 "src/parser.re"
			{ NEWTOKEN(PSI_T_NSNAME); goto start; }
#line 2261 "src/parser.c"
yy185:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy261;
			case 'e':	goto yy262;
			case 'i':	goto yy263;
			case 'r':	goto yy264;
			default:	goto yy62;
			}
yy186:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy224;
			case 'o':	goto yy265;
			default:	goto yy62;
			}
yy187:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy266;
			default:	goto yy62;
			}
yy188:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy226;
			case 'n':	goto yy267;
			default:	goto yy62;
			}
yy189:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'u':	goto yy268;
			default:	goto yy62;
			}
yy190:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy230;
			case 'u':	goto yy269;
			default:	goto yy62;
			}
yy191:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':	goto yy233;
			case 'o':	goto yy270;
			default:	goto yy62;
			}
yy192:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy238;
			case 'T':	goto yy239;
			case 't':	goto yy271;
			default:	goto yy62;
			}
yy193:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy242;
			case 'n':	goto yy273;
			default:	goto yy62;
			}
yy194:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy274;
			default:	goto yy62;
			}
yy195:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy249;
			case 'a':	goto yy275;
			default:	goto yy62;
			}
yy196:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy276;
			default:	goto yy62;
			}
yy197:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy277;
			case 'z':	goto yy278;
			default:	goto yy62;
			}
yy198:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy253;
			case 'R':	goto yy254;
			case 'r':	goto yy279;
			default:	goto yy62;
			}
yy199:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'p':	goto yy280;
			default:	goto yy62;
			}
yy200:
			++cur;
			cur -= 1;
#line 324 "src/parser.re"
			{ char_width = 2; }
#line 2392 "src/parser.c"
yy202:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '"':	goto yy281;
			default:	goto yy62;
			}
yy203:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy283;
			default:	goto yy62;
			}
yy204:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy258;
			case 'i':	goto yy284;
			case 's':	goto yy285;
			default:	goto yy62;
			}
yy205:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy286;
			case 'l':	goto yy287;
			default:	goto yy62;
			}
yy206:
			++cur;
#line 345 "src/parser.re"
			{ NEWTOKEN(PSI_T_OR); goto start; }
#line 2429 "src/parser.c"
yy208:
			++cur;
#line 365 "src/parser.re"
			{ NEWTOKEN(PSI_T_ELLIPSIS); goto start; }
#line 2434 "src/parser.c"
yy210:
			yych = *++cur;
			switch (yych) {
			case 'D':
			case 'd':	goto yy288;
			case 'F':
			case 'f':	goto yy290;
			case 'L':
			case 'l':	goto yy292;
			default:	goto yy114;
			}
yy211:
			++cur;
			cur -= 1;
#line 315 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_F; cur += 1; goto start; }
#line 2451 "src/parser.c"
yy213:
			++cur;
			cur -= 1;
#line 316 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_L; cur += 1; goto start; }
#line 2457 "src/parser.c"
yy215:
			yych = *++cur;
			switch (yych) {
			case 'U':
			case 'u':	goto yy294;
			default:	goto yy114;
			}
yy216:
			++cur;
yy217:
			cur -= 2;
#line 311 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_UL; cur += 2; goto start; }
#line 2471 "src/parser.c"
yy218:
			yych = *++cur;
			switch (yych) {
			case 'L':
			case 'l':	goto yy294;
			default:	goto yy217;
			}
yy219:
			yyaccept = 3;
			mrk = ++cur;
			if ((lim - cur) < 3) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '.':	goto yy296;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy219;
			case 'L':
			case 'l':	goto yy128;
			case 'P':
			case 'p':	goto yy127;
			case 'U':
			case 'u':	goto yy130;
			default:	goto yy39;
			}
yy221:
			++cur;
#line 451 "src/parser.re"
			{ tok += 1; cur -= 1; NEWTOKEN(PSI_T_CPP_HEADER); cur += 1; goto start; }
#line 2520 "src/parser.c"
yy223:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy298;
			case 'V':
			case 'v':	goto yy299;
			default:	goto yy62;
			}
yy224:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy300;
			default:	goto yy62;
			}
yy225:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy301;
			default:	goto yy62;
			}
yy226:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy302;
			default:	goto yy62;
			}
yy227:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy303;
			default:	goto yy62;
			}
yy228:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy304;
			default:	goto yy62;
			}
yy229:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy306;
			default:	goto yy62;
			}
yy230:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy308;
			default:	goto yy62;
			}
yy231:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy309;
			default:	goto yy62;
			}
yy232:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy310;
			default:	goto yy62;
			}
yy233:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy311;
			default:	goto yy62;
			}
yy234:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy312;
			default:	goto yy62;
			}
yy235:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy314;
			default:	goto yy62;
			}
yy236:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy315;
			default:	goto yy62;
			}
yy237:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy316;
			default:	goto yy62;
			}
yy238:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy317;
			default:	goto yy62;
			}
yy239:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy318;
			default:	goto yy62;
			}
yy240:
			yyaccept = 10;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy241;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy241:
#line 424 "src/parser.re"
			{ NEWTOKEN(PSI_T_LET); goto start; }
#line 2733 "src/parser.c"
yy242:
			yyaccept = 11;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy243;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy243:
#line 423 "src/parser.re"
			{ NEWTOKEN(PSI_T_LIB); goto start; }
#line 2808 "src/parser.c"
yy244:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy319;
			default:	goto yy62;
			}
yy245:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy320;
			default:	goto yy62;
			}
yy246:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy322;
			case 'V':
			case 'v':	goto yy323;
			default:	goto yy62;
			}
yy247:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'H':
			case 'h':	goto yy324;
			default:	goto yy62;
			}
yy248:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy325;
			default:	goto yy62;
			}
yy249:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy326;
			default:	goto yy62;
			}
yy250:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy327;
			default:	goto yy62;
			}
yy251:
			yyaccept = 12;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy252;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy252:
#line 425 "src/parser.re"
			{ NEWTOKEN(PSI_T_SET); goto start; }
#line 2940 "src/parser.c"
yy253:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy328;
			default:	goto yy62;
			}
yy254:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy329;
			case 'L':
			case 'l':	goto yy330;
			case 'V':
			case 'v':	goto yy331;
			default:	goto yy62;
			}
yy255:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'P':
			case 'p':	goto yy332;
			default:	goto yy62;
			}
yy256:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy334;
			case 'B':
			case 'b':	goto yy335;
			case 'F':
			case 'f':	goto yy336;
			case 'I':
			case 'i':	goto yy337;
			case 'O':
			case 'o':	goto yy338;
			case 'S':
			case 's':	goto yy339;
			default:	goto yy62;
			}
yy257:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy340;
			default:	goto yy62;
			}
yy258:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy342;
			default:	goto yy62;
			}
yy259:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy343;
			default:	goto yy62;
			}
yy260:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy344;
			default:	goto yy62;
			}
yy261:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy346;
			case 't':	goto yy347;
			default:	goto yy62;
			}
yy262:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'x':	goto yy348;
			default:	goto yy62;
			}
yy263:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy349;
			default:	goto yy62;
			}
yy264:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy350;
			default:	goto yy62;
			}
yy265:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':	goto yy300;
			case 'l':	goto yy351;
			default:	goto yy62;
			}
yy266:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy353;
			default:	goto yy62;
			}
yy267:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy355;
			default:	goto yy62;
			}
yy268:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'b':	goto yy356;
			default:	goto yy62;
			}
yy269:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy357;
			default:	goto yy62;
			}
yy270:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':	goto yy311;
			case 'a':	goto yy359;
			default:	goto yy62;
			}
yy271:
			yyaccept = 13;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy272;
			case '1':	goto yy360;
			case '3':	goto yy361;
			case '6':	goto yy362;
			case '8':	goto yy363;
			case 'V':
			case 'v':	goto yy318;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy272:
#line 385 "src/parser.re"
			{ NEWTOKEN(PSI_T_INT); goto start; }
#line 3172 "src/parser.c"
yy273:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy364;
			default:	goto yy62;
			}
yy274:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy366;
			default:	goto yy62;
			}
yy275:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy368;
			default:	goto yy62;
			}
yy276:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy369;
			default:	goto yy62;
			}
yy277:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy370;
			default:	goto yy62;
			}
yy278:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy371;
			default:	goto yy62;
			}
yy279:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy329;
			case 'L':
			case 'l':	goto yy330;
			case 'V':
			case 'v':	goto yy331;
			case 'u':	goto yy372;
			default:	goto yy62;
			}
yy280:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy373;
			default:	goto yy62;
			}
yy281:
			++cur;
			cur -= 1;
#line 323 "src/parser.re"
			{ char_width = 1; }
#line 3240 "src/parser.c"
yy283:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy374;
			default:	goto yy62;
			}
yy284:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy375;
			default:	goto yy62;
			}
yy285:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy376;
			default:	goto yy62;
			}
yy286:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy377;
			default:	goto yy62;
			}
yy287:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy379;
			default:	goto yy62;
			}
yy288:
			++cur;
			cur -= 2;
#line 318 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DD; cur += 2; goto start; }
#line 3281 "src/parser.c"
yy290:
			++cur;
			cur -= 2;
#line 317 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DF; cur += 2; goto start; }
#line 3287 "src/parser.c"
yy292:
			++cur;
			cur -= 2;
#line 319 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_FLT | PSI_NUMBER_DL; cur += 2; goto start; }
#line 3293 "src/parser.c"
yy294:
			++cur;
			cur -= 3;
#line 312 "src/parser.re"
			{ NEWTOKEN(PSI_T_NUMBER); token->flags = PSI_NUMBER_INT | PSI_NUMBER_ULL; cur += 3; goto start; }
#line 3299 "src/parser.c"
yy296:
			++cur;
			if ((lim - cur) < 3) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':	goto yy296;
			case 'P':
			case 'p':	goto yy127;
			default:	goto yy114;
			}
yy298:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'Y':
			case 'y':	goto yy380;
			default:	goto yy62;
			}
yy299:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy382;
			default:	goto yy62;
			}
yy300:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy383;
			default:	goto yy62;
			}
yy301:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy384;
			case 'B':
			case 'b':	goto yy385;
			case 'O':
			case 'o':	goto yy386;
			default:	goto yy62;
			}
yy302:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy387;
			default:	goto yy62;
			}
yy303:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy389;
			default:	goto yy62;
			}
yy304:
			yyaccept = 14;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy305;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy305:
#line 403 "src/parser.re"
			{ NEWTOKEN(PSI_T_ELIF); goto start; }
#line 3457 "src/parser.c"
yy306:
			yyaccept = 15;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy307;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy307:
#line 402 "src/parser.re"
			{ NEWTOKEN(PSI_T_ELSE); goto start; }
#line 3532 "src/parser.c"
yy308:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy390;
			default:	goto yy62;
			}
yy309:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy392;
			default:	goto yy62;
			}
yy310:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy394;
			default:	goto yy62;
			}
yy311:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy396;
			default:	goto yy62;
			}
yy312:
			yyaccept = 16;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy313;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy313:
#line 429 "src/parser.re"
			{ NEWTOKEN(PSI_T_FREE); goto start; }
#line 3639 "src/parser.c"
yy314:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy397;
			default:	goto yy62;
			}
yy315:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy398;
			default:	goto yy62;
			}
yy316:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy400;
			default:	goto yy62;
			}
yy317:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'U':
			case 'u':	goto yy401;
			default:	goto yy62;
			}
yy318:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy402;
			default:	goto yy62;
			}
yy319:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy403;
			default:	goto yy62;
			}
yy320:
			yyaccept = 17;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy321;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy321:
#line 414 "src/parser.re"
			{ NEWTOKEN(PSI_T_NULL); goto start; }
#line 3762 "src/parser.c"
yy322:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy405;
			default:	goto yy62;
			}
yy323:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy406;
			default:	goto yy62;
			}
yy324:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy407;
			default:	goto yy62;
			}
yy325:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy408;
			default:	goto yy62;
			}
yy326:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy409;
			default:	goto yy62;
			}
yy327:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy410;
			default:	goto yy62;
			}
yy328:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy411;
			default:	goto yy62;
			}
yy329:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy412;
			default:	goto yy62;
			}
yy330:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy413;
			default:	goto yy62;
			}
yy331:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy414;
			default:	goto yy62;
			}
yy332:
			yyaccept = 18;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy333;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy333:
#line 430 "src/parser.re"
			{ NEWTOKEN(PSI_T_TEMP); goto start; }
#line 3916 "src/parser.c"
yy334:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy415;
			default:	goto yy62;
			}
yy335:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy416;
			default:	goto yy62;
			}
yy336:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy417;
			default:	goto yy62;
			}
yy337:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy418;
			default:	goto yy62;
			}
yy338:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy419;
			default:	goto yy62;
			}
yy339:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy420;
			default:	goto yy62;
			}
yy340:
			yyaccept = 19;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy341;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy341:
#line 412 "src/parser.re"
			{ NEWTOKEN(PSI_T_TRUE); goto start; }
#line 4039 "src/parser.c"
yy342:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy421;
			default:	goto yy62;
			}
yy343:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy423;
			default:	goto yy62;
			}
yy344:
			yyaccept = 20;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy345;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy345:
#line 439 "src/parser.re"
			{ NEWTOKEN(PSI_T_ZVAL); goto start; }
#line 4130 "src/parser.c"
yy346:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy424;
			default:	goto yy62;
			}
yy347:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy425;
			default:	goto yy62;
			}
yy348:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy426;
			default:	goto yy62;
			}
yy349:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy427;
			default:	goto yy62;
			}
yy350:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy428;
			default:	goto yy62;
			}
yy351:
			yyaccept = 21;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy352;
			case 'V':
			case 'v':	goto yy383;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy352:
#line 382 "src/parser.re"
			{ NEWTOKEN(PSI_T_BOOL); goto start; }
#line 4242 "src/parser.c"
yy353:
			yyaccept = 22;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy354;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy354:
#line 383 "src/parser.re"
			{ NEWTOKEN(PSI_T_CHAR); goto start; }
#line 4317 "src/parser.c"
yy355:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy429;
			default:	goto yy62;
			}
yy356:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy431;
			default:	goto yy62;
			}
yy357:
			yyaccept = 23;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy358;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy358:
#line 379 "src/parser.re"
			{ NEWTOKEN(PSI_T_ENUM); goto start; }
#line 4406 "src/parser.c"
yy359:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':	goto yy396;
			case 't':	goto yy432;
			default:	goto yy62;
			}
yy360:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '6':	goto yy434;
			default:	goto yy62;
			}
yy361:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '2':	goto yy435;
			default:	goto yy62;
			}
yy362:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '4':	goto yy436;
			default:	goto yy62;
			}
yy363:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy437;
			default:	goto yy62;
			}
yy364:
			yyaccept = 24;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy365;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy365:
#line 375 "src/parser.re"
			{ NEWTOKEN(PSI_T_LINE); goto start; }
#line 4517 "src/parser.c"
yy366:
			yyaccept = 25;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy367;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy367:
#line 386 "src/parser.re"
			{ NEWTOKEN(PSI_T_LONG); goto start; }
#line 4592 "src/parser.c"
yy368:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'm':	goto yy438;
			default:	goto yy62;
			}
yy369:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy439;
			default:	goto yy62;
			}
yy370:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy441;
			default:	goto yy62;
			}
yy371:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy442;
			default:	goto yy62;
			}
yy372:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'c':	goto yy443;
			default:	goto yy62;
			}
yy373:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy444;
			default:	goto yy62;
			}
yy374:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '1':	goto yy445;
			case '3':	goto yy446;
			case '6':	goto yy447;
			case '8':	goto yy448;
			default:	goto yy62;
			}
yy375:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy449;
			default:	goto yy62;
			}
yy376:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'g':	goto yy451;
			default:	goto yy62;
			}
yy377:
			yyaccept = 26;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy378;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy378:
#line 381 "src/parser.re"
			{ NEWTOKEN(PSI_T_VOID); goto start; }
#line 4733 "src/parser.c"
yy379:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy452;
			default:	goto yy62;
			}
yy380:
			yyaccept = 27;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy381;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy381:
#line 418 "src/parser.re"
			{ NEWTOKEN(PSI_T_ARRAY); goto start; }
#line 4815 "src/parser.c"
yy382:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy453;
			default:	goto yy62;
			}
yy383:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy455;
			default:	goto yy62;
			}
yy384:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'B':
			case 'b':	goto yy456;
			default:	goto yy62;
			}
yy385:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy457;
			default:	goto yy62;
			}
yy386:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy458;
			default:	goto yy62;
			}
yy387:
			yyaccept = 28;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy388;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy388:
#line 440 "src/parser.re"
			{ NEWTOKEN(PSI_T_COUNT); goto start; }
#line 4930 "src/parser.c"
yy389:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy460;
			default:	goto yy62;
			}
yy390:
			yyaccept = 29;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy391;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy391:
#line 404 "src/parser.re"
			{ NEWTOKEN(PSI_T_ENDIF); goto start; }
#line 5013 "src/parser.c"
yy392:
			yyaccept = 30;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy393;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy393:
#line 409 "src/parser.re"
			{ NEWTOKEN(PSI_T_ERROR); goto start; }
#line 5088 "src/parser.c"
yy394:
			yyaccept = 31;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy395;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy395:
#line 413 "src/parser.re"
			{ NEWTOKEN(PSI_T_FALSE); goto start; }
#line 5163 "src/parser.c"
yy396:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'V':
			case 'v':	goto yy462;
			default:	goto yy62;
			}
yy397:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy463;
			default:	goto yy62;
			}
yy398:
			yyaccept = 32;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy399;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy399:
#line 400 "src/parser.re"
			{ NEWTOKEN(PSI_T_IFDEF); goto start; }
#line 5254 "src/parser.c"
yy400:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'F':
			case 'f':	goto yy464;
			default:	goto yy62;
			}
yy401:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'D':
			case 'd':	goto yy466;
			default:	goto yy62;
			}
yy402:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy467;
			default:	goto yy62;
			}
yy403:
			yyaccept = 33;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy404;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy404:
#line 415 "src/parser.re"
			{ NEWTOKEN(PSI_T_MIXED); goto start; }
#line 5353 "src/parser.c"
yy405:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy469;
			default:	goto yy62;
			}
yy406:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy471;
			default:	goto yy62;
			}
yy407:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy473;
			default:	goto yy62;
			}
yy408:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy474;
			default:	goto yy62;
			}
yy409:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy475;
			default:	goto yy62;
			}
yy410:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy476;
			default:	goto yy62;
			}
yy411:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy478;
			default:	goto yy62;
			}
yy412:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy480;
			default:	goto yy62;
			}
yy413:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy482;
			default:	goto yy62;
			}
yy414:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy484;
			default:	goto yy62;
			}
yy415:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy486;
			default:	goto yy62;
			}
yy416:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy487;
			default:	goto yy62;
			}
yy417:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy488;
			default:	goto yy62;
			}
yy418:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy489;
			default:	goto yy62;
			}
yy419:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'J':
			case 'j':	goto yy491;
			default:	goto yy62;
			}
yy420:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy492;
			default:	goto yy62;
			}
yy421:
			yyaccept = 34;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy422;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy422:
#line 407 "src/parser.re"
			{ NEWTOKEN(PSI_T_UNDEF); goto start; }
#line 5556 "src/parser.c"
yy423:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy493;
			default:	goto yy62;
			}
yy424:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy494;
			default:	goto yy62;
			}
yy425:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy495;
			default:	goto yy62;
			}
yy426:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy496;
			default:	goto yy62;
			}
yy427:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy497;
			default:	goto yy62;
			}
yy428:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy498;
			default:	goto yy62;
			}
yy429:
			yyaccept = 35;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy430;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy430:
#line 380 "src/parser.re"
			{ NEWTOKEN(PSI_T_CONST); goto start; }
#line 5674 "src/parser.c"
yy431:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy499;
			default:	goto yy62;
			}
yy432:
			yyaccept = 36;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy433;
			case 'V':
			case 'v':	goto yy462;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy433:
#line 387 "src/parser.re"
			{ NEWTOKEN(PSI_T_FLOAT); goto start; }
#line 5758 "src/parser.c"
yy434:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy501;
			default:	goto yy62;
			}
yy435:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy502;
			default:	goto yy62;
			}
yy436:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy503;
			default:	goto yy62;
			}
yy437:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy504;
			default:	goto yy62;
			}
yy438:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'a':	goto yy506;
			default:	goto yy62;
			}
yy439:
			yyaccept = 37;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy440;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy440:
#line 384 "src/parser.re"
			{ NEWTOKEN(PSI_T_SHORT); goto start; }
#line 5868 "src/parser.c"
yy441:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy508;
			default:	goto yy62;
			}
yy442:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'f':	goto yy510;
			default:	goto yy62;
			}
yy443:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy512;
			default:	goto yy62;
			}
yy444:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy514;
			default:	goto yy62;
			}
yy445:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '6':	goto yy515;
			default:	goto yy62;
			}
yy446:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '2':	goto yy516;
			default:	goto yy62;
			}
yy447:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '4':	goto yy517;
			default:	goto yy62;
			}
yy448:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy518;
			default:	goto yy62;
			}
yy449:
			yyaccept = 38;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy450;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy450:
#line 378 "src/parser.re"
			{ NEWTOKEN(PSI_T_UNION); goto start; }
#line 5999 "src/parser.c"
yy451:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy519;
			default:	goto yy62;
			}
yy452:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy520;
			default:	goto yy62;
			}
yy453:
			yyaccept = 39;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy454;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy454:
#line 437 "src/parser.re"
			{ NEWTOKEN(PSI_T_ARRVAL); goto start; }
#line 6088 "src/parser.c"
yy455:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy521;
			default:	goto yy62;
			}
yy456:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy523;
			default:	goto yy62;
			}
yy457:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy524;
			default:	goto yy62;
			}
yy458:
			yyaccept = 40;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy459;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy459:
#line 441 "src/parser.re"
			{ NEWTOKEN(PSI_T_CALLOC); goto start; }
#line 6187 "src/parser.c"
yy460:
			yyaccept = 41;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy461;
			case 'D':
			case 'd':	goto yy525;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy461:
#line 405 "src/parser.re"
			{ NEWTOKEN(PSI_T_DEFINE); goto start; }
#line 6264 "src/parser.c"
yy462:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy527;
			default:	goto yy62;
			}
yy463:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'O':
			case 'o':	goto yy528;
			default:	goto yy62;
			}
yy464:
			yyaccept = 42;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy465;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy465:
#line 401 "src/parser.re"
			{ NEWTOKEN(PSI_T_IFNDEF); goto start; }
#line 6355 "src/parser.c"
yy466:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy529;
			default:	goto yy62;
			}
yy467:
			yyaccept = 43;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy468;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy468:
#line 434 "src/parser.re"
			{ NEWTOKEN(PSI_T_INTVAL); goto start; }
#line 6438 "src/parser.c"
yy469:
			yyaccept = 44;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy470;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy470:
#line 419 "src/parser.re"
			{ NEWTOKEN(PSI_T_OBJECT); goto start; }
#line 6513 "src/parser.c"
yy471:
			yyaccept = 45;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy472;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy472:
#line 438 "src/parser.re"
			{ NEWTOKEN(PSI_T_OBJVAL); goto start; }
#line 6588 "src/parser.c"
yy473:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy531;
			default:	goto yy62;
			}
yy474:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy533;
			default:	goto yy62;
			}
yy475:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy534;
			default:	goto yy62;
			}
yy476:
			yyaccept = 46;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy477;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy477:
#line 428 "src/parser.re"
			{ NEWTOKEN(PSI_T_RETURN); goto start; }
#line 6687 "src/parser.c"
yy478:
			yyaccept = 47;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy479;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy479:
#line 421 "src/parser.re"
			{ NEWTOKEN(PSI_T_STATIC); goto start; }
#line 6762 "src/parser.c"
yy480:
			yyaccept = 48;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy481;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy481:
#line 417 "src/parser.re"
			{ NEWTOKEN(PSI_T_STRING); goto start; }
#line 6837 "src/parser.c"
yy482:
			yyaccept = 49;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy483;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy483:
#line 431 "src/parser.re"
			{ NEWTOKEN(PSI_T_STRLEN); goto start; }
#line 6912 "src/parser.c"
yy484:
			yyaccept = 50;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy485;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy485:
#line 432 "src/parser.re"
			{ NEWTOKEN(PSI_T_STRVAL); goto start; }
#line 6987 "src/parser.c"
yy486:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy535;
			default:	goto yy62;
			}
yy487:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy536;
			default:	goto yy62;
			}
yy488:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'A':
			case 'a':	goto yy538;
			default:	goto yy62;
			}
yy489:
			yyaccept = 51;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy490;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy490:
#line 445 "src/parser.re"
			{ NEWTOKEN(PSI_T_TO_INT); goto start; }
#line 7086 "src/parser.c"
yy491:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy539;
			default:	goto yy62;
			}
yy492:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'I':
			case 'i':	goto yy540;
			default:	goto yy62;
			}
yy493:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy541;
			default:	goto yy62;
			}
yy494:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy543;
			default:	goto yy62;
			}
yy495:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy545;
			default:	goto yy62;
			}
yy496:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy546;
			default:	goto yy62;
			}
yy497:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy547;
			default:	goto yy62;
			}
yy498:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'r':	goto yy548;
			default:	goto yy62;
			}
yy499:
			yyaccept = 52;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy500;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy500:
#line 388 "src/parser.re"
			{ NEWTOKEN(PSI_T_DOUBLE); goto start; }
#line 7220 "src/parser.c"
yy501:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy549;
			default:	goto yy62;
			}
yy502:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy551;
			default:	goto yy62;
			}
yy503:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy553;
			default:	goto yy62;
			}
yy504:
			yyaccept = 53;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy505;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy505:
#line 389 "src/parser.re"
			{ NEWTOKEN(PSI_T_INT8); goto start; }
#line 7316 "src/parser.c"
yy506:
			yyaccept = 54;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy507;
			case '\\':	goto yy146;
			default:	goto yy555;
			}
yy507:
#line 367 "src/parser.re"
			{ NEWTOKEN(PSI_T_PRAGMA); goto start; }
#line 7391 "src/parser.c"
yy508:
			yyaccept = 55;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy509;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy509:
#line 398 "src/parser.re"
			{ NEWTOKEN(PSI_T_SIGNED); goto start; }
#line 7466 "src/parser.c"
yy510:
			yyaccept = 56;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy511;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy511:
#line 374 "src/parser.re"
			{ NEWTOKEN(PSI_T_SIZEOF); goto start; }
#line 7541 "src/parser.c"
yy512:
			yyaccept = 57;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy513;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy513:
#line 377 "src/parser.re"
			{ NEWTOKEN(PSI_T_STRUCT); goto start; }
#line 7616 "src/parser.c"
yy514:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'f':	goto yy557;
			default:	goto yy62;
			}
yy515:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy559;
			default:	goto yy62;
			}
yy516:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy560;
			default:	goto yy62;
			}
yy517:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy561;
			default:	goto yy62;
			}
yy518:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy562;
			default:	goto yy62;
			}
yy519:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy564;
			default:	goto yy62;
			}
yy520:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'l':	goto yy565;
			default:	goto yy62;
			}
yy521:
			yyaccept = 58;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy522;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy522:
#line 436 "src/parser.re"
			{ NEWTOKEN(PSI_T_BOOLVAL); goto start; }
#line 7740 "src/parser.c"
yy523:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy566;
			default:	goto yy62;
			}
yy524:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'K':
			case 'k':	goto yy568;
			default:	goto yy62;
			}
yy525:
			yyaccept = 59;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy526;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy526:
#line 406 "src/parser.re"
			{ NEWTOKEN(PSI_T_DEFINED); goto start; }
#line 7831 "src/parser.c"
yy527:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'L':
			case 'l':	goto yy570;
			default:	goto yy62;
			}
yy528:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy572;
			default:	goto yy62;
			}
yy529:
			yyaccept = 60;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy530;
			case '\\':	goto yy146;
			case '_':	goto yy574;
			default:	goto yy61;
			}
yy530:
#line 410 "src/parser.re"
			{ NEWTOKEN(PSI_T_INCLUDE); goto start; }
#line 7923 "src/parser.c"
yy531:
			yyaccept = 61;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy532;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy532:
#line 433 "src/parser.re"
			{ NEWTOKEN(PSI_T_PATHVAL); goto start; }
#line 7998 "src/parser.c"
yy533:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'S':
			case 's':	goto yy575;
			default:	goto yy62;
			}
yy534:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy576;
			default:	goto yy62;
			}
yy535:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'Y':
			case 'y':	goto yy577;
			default:	goto yy62;
			}
yy536:
			yyaccept = 62;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy537;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy537:
#line 447 "src/parser.re"
			{ NEWTOKEN(PSI_T_TO_BOOL); goto start; }
#line 8097 "src/parser.c"
yy538:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy579;
			default:	goto yy62;
			}
yy539:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'C':
			case 'c':	goto yy581;
			default:	goto yy62;
			}
yy540:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy582;
			default:	goto yy62;
			}
yy541:
			yyaccept = 63;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy542;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy542:
#line 408 "src/parser.re"
			{ NEWTOKEN(PSI_T_WARNING); goto start; }
#line 8196 "src/parser.c"
yy543:
			yyaccept = 64;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy544;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy544:
#line 372 "src/parser.re"
			{ NEWTOKEN(PSI_T_CPP_ASM); goto start; }
#line 8271 "src/parser.c"
yy545:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'b':	goto yy583;
			default:	goto yy62;
			}
yy546:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 's':	goto yy584;
			default:	goto yy62;
			}
yy547:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy585;
			default:	goto yy62;
			}
yy548:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy587;
			default:	goto yy62;
			}
yy549:
			yyaccept = 65;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy550;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy550:
#line 391 "src/parser.re"
			{ NEWTOKEN(PSI_T_INT16); goto start; }
#line 8374 "src/parser.c"
yy551:
			yyaccept = 66;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy552;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy552:
#line 393 "src/parser.re"
			{ NEWTOKEN(PSI_T_INT32); goto start; }
#line 8449 "src/parser.c"
yy553:
			yyaccept = 67;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy554;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy554:
#line 395 "src/parser.re"
			{ NEWTOKEN(PSI_T_INT64); goto start; }
#line 8524 "src/parser.c"
yy555:
			yyaccept = 5;
			mrk = ++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy146;
			case 'o':	goto yy588;
			default:	goto yy555;
			}
yy557:
			yyaccept = 68;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy558;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy558:
#line 376 "src/parser.re"
			{ NEWTOKEN(PSI_T_TYPEDEF); goto start; }
#line 8673 "src/parser.c"
yy559:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy590;
			default:	goto yy62;
			}
yy560:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy592;
			default:	goto yy62;
			}
yy561:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy594;
			default:	goto yy62;
			}
yy562:
			yyaccept = 69;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy563;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy563:
#line 390 "src/parser.re"
			{ NEWTOKEN(PSI_T_UINT8); goto start; }
#line 8769 "src/parser.c"
yy564:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'd':	goto yy596;
			default:	goto yy62;
			}
yy565:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy598;
			default:	goto yy62;
			}
yy566:
			yyaccept = 70;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy567;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy567:
#line 416 "src/parser.re"
			{ NEWTOKEN(PSI_T_CALLABLE); goto start; }
#line 8858 "src/parser.c"
yy568:
			yyaccept = 71;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy569;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy569:
#line 420 "src/parser.re"
			{ NEWTOKEN(PSI_T_CALLBACK); goto start; }
#line 8933 "src/parser.c"
yy570:
			yyaccept = 72;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy571;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy571:
#line 435 "src/parser.re"
			{ NEWTOKEN(PSI_T_FLOATVAL); goto start; }
#line 9008 "src/parser.c"
yy572:
			yyaccept = 73;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy573;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy573:
#line 422 "src/parser.re"
			{ NEWTOKEN(PSI_T_FUNCTION); goto start; }
#line 9083 "src/parser.c"
yy574:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'N':
			case 'n':	goto yy600;
			default:	goto yy62;
			}
yy575:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy601;
			default:	goto yy62;
			}
yy576:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy602;
			default:	goto yy62;
			}
yy577:
			yyaccept = 74;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy578;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy578:
#line 443 "src/parser.re"
			{ NEWTOKEN(PSI_T_TO_ARRAY); goto start; }
#line 9182 "src/parser.c"
yy579:
			yyaccept = 75;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy580;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy580:
#line 446 "src/parser.re"
			{ NEWTOKEN(PSI_T_TO_FLOAT); goto start; }
#line 9257 "src/parser.c"
yy581:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy603;
			default:	goto yy62;
			}
yy582:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'G':
			case 'g':	goto yy605;
			default:	goto yy62;
			}
yy583:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'u':	goto yy607;
			default:	goto yy62;
			}
yy584:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'i':	goto yy608;
			default:	goto yy62;
			}
yy585:
			yyaccept = 76;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy586;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy586:
#line 369 "src/parser.re"
			{ NEWTOKEN(PSI_T_CPP_INLINE); goto start; }
#line 9362 "src/parser.c"
yy587:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'c':	goto yy609;
			default:	goto yy62;
			}
yy588:
			yyaccept = 5;
			mrk = ++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy146;
			case 'n':	goto yy610;
			case 'o':	goto yy588;
			default:	goto yy555;
			}
yy590:
			yyaccept = 77;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy591;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy591:
#line 392 "src/parser.re"
			{ NEWTOKEN(PSI_T_UINT16); goto start; }
#line 9519 "src/parser.c"
yy592:
			yyaccept = 78;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy593;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy593:
#line 394 "src/parser.re"
			{ NEWTOKEN(PSI_T_UINT32); goto start; }
#line 9594 "src/parser.c"
yy594:
			yyaccept = 79;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy595;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy595:
#line 396 "src/parser.re"
			{ NEWTOKEN(PSI_T_UINT64); goto start; }
#line 9669 "src/parser.c"
yy596:
			yyaccept = 80;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy597;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy597:
#line 397 "src/parser.re"
			{ NEWTOKEN(PSI_T_UNSIGNED); goto start; }
#line 9744 "src/parser.c"
yy598:
			yyaccept = 81;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy599;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy599:
#line 373 "src/parser.re"
			{ NEWTOKEN(PSI_T_VOLATILE); goto start; }
#line 9819 "src/parser.c"
yy600:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'E':
			case 'e':	goto yy611;
			default:	goto yy62;
			}
yy601:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'R':
			case 'r':	goto yy612;
			default:	goto yy62;
			}
yy602:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy613;
			default:	goto yy62;
			}
yy603:
			yyaccept = 82;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy604;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy604:
#line 442 "src/parser.re"
			{ NEWTOKEN(PSI_T_TO_OBJECT); goto start; }
#line 9918 "src/parser.c"
yy605:
			yyaccept = 83;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy606;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy606:
#line 444 "src/parser.re"
			{ NEWTOKEN(PSI_T_TO_STRING); goto start; }
#line 9993 "src/parser.c"
yy607:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy615;
			default:	goto yy62;
			}
yy608:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'o':	goto yy616;
			default:	goto yy62;
			}
yy609:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 't':	goto yy617;
			default:	goto yy62;
			}
yy610:
			yyaccept = 5;
			mrk = ++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy146;
			case 'c':	goto yy619;
			case 'o':	goto yy588;
			default:	goto yy555;
			}
yy611:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'X':
			case 'x':	goto yy620;
			default:	goto yy62;
			}
yy612:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy621;
			default:	goto yy62;
			}
yy613:
			yyaccept = 84;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy614;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy614:
#line 426 "src/parser.re"
			{ NEWTOKEN(PSI_T_PRE_ASSERT); goto start; }
#line 10180 "src/parser.c"
yy615:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'e':	goto yy623;
			default:	goto yy62;
			}
yy616:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'n':	goto yy624;
			default:	goto yy62;
			}
yy617:
			yyaccept = 85;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy618;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy618:
#line 370 "src/parser.re"
			{ NEWTOKEN(PSI_T_CPP_RESTRICT); goto start; }
#line 10269 "src/parser.c"
yy619:
			yyaccept = 5;
			mrk = ++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy55;
			case '\\':	goto yy146;
			case 'e':	goto yy625;
			case 'o':	goto yy588;
			default:	goto yy555;
			}
yy620:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 'T':
			case 't':	goto yy627;
			default:	goto yy62;
			}
yy621:
			yyaccept = 86;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy622;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy622:
#line 427 "src/parser.re"
			{ NEWTOKEN(PSI_T_POST_ASSERT); goto start; }
#line 10427 "src/parser.c"
yy623:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy629;
			default:	goto yy62;
			}
yy624:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy630;
			default:	goto yy62;
			}
yy625:
			yyaccept = 87;
			mrk = ++cur;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy626;
			case '\\':	goto yy146;
			case 'o':	goto yy588;
			default:	goto yy555;
			}
yy626:
#line 368 "src/parser.re"
			{ NEWTOKEN(PSI_T_PRAGMA_ONCE); goto start; }
#line 10519 "src/parser.c"
yy627:
			yyaccept = 88;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy628;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy628:
#line 411 "src/parser.re"
			{ NEWTOKEN(PSI_T_INCLUDE_NEXT); goto start; }
#line 10594 "src/parser.c"
yy629:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy631;
			default:	goto yy62;
			}
yy630:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '_':	goto yy632;
			default:	goto yy62;
			}
yy631:
			yyaccept = 5;
			yych = *(mrk = ++cur);
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy634;
			case '(':	goto yy636;
			default:	goto yy62;
			}
yy632:
			yyaccept = 89;
			yych = *(mrk = ++cur);
			switch (yych) {
			case 0x00:
			case 0x01:
			case 0x02:
			case 0x03:
			case 0x04:
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
			case '\t':
			case '\n':
			case '\v':
			case '\f':
			case '\r':
			case 0x0E:
			case 0x0F:
			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
			case 0x18:
			case 0x19:
			case 0x1A:
			case 0x1B:
			case 0x1C:
			case 0x1D:
			case 0x1E:
			case 0x1F:
			case ' ':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case '&':
			case '\'':
			case '(':
			case ')':
			case '*':
			case '+':
			case ',':
			case '-':
			case '.':
			case '/':
			case ':':
			case ';':
			case '<':
			case '=':
			case '>':
			case '?':
			case '@':
			case '[':
			case ']':
			case '^':
			case '`':
			case '{':
			case '|':
			case '}':
			case '~':
			case 0x7F:	goto yy633;
			case '\\':	goto yy146;
			default:	goto yy61;
			}
yy633:
#line 371 "src/parser.re"
			{ NEWTOKEN(PSI_T_CPP_EXTENSION); goto start; }
#line 10693 "src/parser.c"
yy634:
			++cur;
			if ((lim - cur) < 2) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '\t':
			case '\f':
			case ' ':	goto yy634;
			case '(':	goto yy636;
			default:	goto yy114;
			}
yy636:
			yych = *++cur;
			switch (yych) {
			case '(':	goto yy637;
			default:	goto yy114;
			}
yy637:
			++cur;
#line 452 "src/parser.re"
			{ parens = 2; goto cpp_attribute; }
#line 10715 "src/parser.c"
		}
#line 458 "src/parser.re"


	character: ;
		
#line 10722 "src/parser.c"
		{
			unsigned char yych;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy643;
			case '\'':	goto yy645;
			case '\\':	goto yy647;
			default:	goto yy641;
			}
yy641:
			++cur;
#line 476 "src/parser.re"
			{ escaped = false; goto character; }
#line 10738 "src/parser.c"
yy643:
			++cur;
#line 463 "src/parser.re"
			{ NEWLINE(); goto character; }
#line 10743 "src/parser.c"
yy645:
			++cur;
#line 465 "src/parser.re"
			{
			if (escaped) {
				escaped = false;
				goto character;
			}
			cur -= 1;
			NEWTOKEN(PSI_T_QUOTED_CHAR);
			cur += 1;
			token->flags = char_width;
			goto start;
		}
#line 10758 "src/parser.c"
yy647:
			++cur;
#line 464 "src/parser.re"
			{ escaped = !escaped;  goto character; }
#line 10763 "src/parser.c"
		}
#line 478 "src/parser.re"


	string: ;
		
#line 10770 "src/parser.c"
		{
			unsigned char yych;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy653;
			case '"':	goto yy655;
			case '\\':	goto yy657;
			default:	goto yy651;
			}
yy651:
			++cur;
#line 496 "src/parser.re"
			{ escaped = false; goto string; }
#line 10786 "src/parser.c"
yy653:
			++cur;
#line 483 "src/parser.re"
			{ NEWLINE(); goto string; }
#line 10791 "src/parser.c"
yy655:
			++cur;
#line 485 "src/parser.re"
			{
			if (escaped) {
				escaped = false;
				goto string;
			}
			cur -= 1;
			NEWTOKEN(PSI_T_QUOTED_STRING);
			cur += 1;
			token->flags = char_width;
			goto start;
		}
#line 10806 "src/parser.c"
yy657:
			++cur;
#line 484 "src/parser.re"
			{ escaped = !escaped; goto string; }
#line 10811 "src/parser.c"
		}
#line 498 "src/parser.re"


	comment: ;
		
#line 10818 "src/parser.c"
		{
			unsigned char yych;
			if ((lim - cur) < 2) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy663;
			case '*':	goto yy665;
			default:	goto yy661;
			}
yy661:
			++cur;
yy662:
#line 505 "src/parser.re"
			{ goto comment; }
#line 10834 "src/parser.c"
yy663:
			++cur;
#line 503 "src/parser.re"
			{ NEWLINE(); goto comment; }
#line 10839 "src/parser.c"
yy665:
			yych = *++cur;
			switch (yych) {
			case '/':	goto yy666;
			default:	goto yy662;
			}
yy666:
			++cur;
#line 504 "src/parser.re"
			{ NEWTOKEN(PSI_T_COMMENT); goto start; }
#line 10850 "src/parser.c"
		}
#line 507 "src/parser.re"


	comment_sl: ;
		
#line 10857 "src/parser.c"
		{
			unsigned char yych;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy672;
			default:	goto yy670;
			}
yy670:
			++cur;
#line 513 "src/parser.re"
			{ goto comment_sl; }
#line 10871 "src/parser.c"
yy672:
			++cur;
#line 512 "src/parser.re"
			{ NEWTOKEN(PSI_T_COMMENT); NEWLINE(); goto start; }
#line 10876 "src/parser.c"
		}
#line 515 "src/parser.re"


	cpp_attribute: ;

		
#line 10884 "src/parser.c"
		{
			unsigned char yych;
			if (lim <= cur) if (cur >= lim) goto done;;
			yych = *cur;
			switch (yych) {
			case '\n':
			case '\r':	goto yy678;
			case '(':	goto yy680;
			case ')':	goto yy682;
			default:	goto yy676;
			}
yy676:
			++cur;
#line 524 "src/parser.re"
			{ goto cpp_attribute; }
#line 10900 "src/parser.c"
yy678:
			++cur;
#line 523 "src/parser.re"
			{ NEWLINE(); goto cpp_attribute; }
#line 10905 "src/parser.c"
yy680:
			++cur;
#line 521 "src/parser.re"
			{ ++parens; goto cpp_attribute; }
#line 10910 "src/parser.c"
yy682:
			++cur;
#line 522 "src/parser.re"
			{ if (parens == 1) { NEWTOKEN(PSI_T_CPP_ATTRIBUTE); goto start; } else { --parens; goto cpp_attribute; } }
#line 10915 "src/parser.c"
		}
#line 526 "src/parser.re"

error: ;

	P->error(PSI_DATA(P), token, PSI_WARNING, "PSI syntax error: unexpected input (%d) '%.*s' at col %tu",
			token->type, token->size, token->text, tok - eol + 1);
	psi_plist_free(tokens);
	return NULL;

done:

	PSI_DEBUG_PRINT(P, "PSI: EOF cur=%p lim=%p\n", cur, lim);

	return tokens;
}
